@Echo off

::	* * * * * * * * * * * * * *
::	*   Add  to Self  Radio   *
::	*           By            *
::	*   RainBawZ / kukpappa™  *
::	* * * * * * * * * * * * * *


setlocal enabledelayedexpansion
set version=1.6.2
color 8F
title Add To Self Radio v!version!
:: Prepare required paths
for /f "skip=2 tokens=2,*" %%A in ('reg query "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders" /v "Personal"') do (
	set userDir=%%B
)
set musicDir=Rockstar Games\GTA V\User Music
:: Check if the usermusic directory is correct
if not exist "!userDir!\!musicDir!" (
	Echo x=msgbox^("Unable to find the music directory." ^& vbcrlf ^& "Assumed path: !userDir!\!musicDir!" ,48, "Error"^)>"%temp%\msg.vbs"
	start %temp%\msg.vbs
	endlocal
	exit /b 1
)
cd "%~dp0"
:: Query the registry for the default .mp3 player
for /f "skip=2 tokens=3*" %%A in ('reg query HKCR\.mp3 /ve') do (
	set val=%%A
	:: Check if Add to Self Radio is already installed
	reg query "HKCR\!val!\shell\Add to Self Radio\command" /ve > nul
	if !errorlevel!==1 (
		set action=_
		cls
		Echo.
		Echo NOTE: If you've previously used an older version of
		Echo       this software, you should run the uninstaller
		Echo       from that version before continuing.
		Echo.
		Echo Would you like to add a shortcut to the Context Menu?
		Echo.
		set /p action="Y/N >> "
		if !action!==_ (
			goto :end
		)
		if /i !action!==y (
			:: Add registry key
			reg add "HKCR\!val!\shell\Add to Self Radio\command" /ve /d "%~f0 ""%%1""" >"%temp%\stderr.txt" 2>&1
			if !errorlevel!==1 (
				Echo x=msgbox^("An error occurred. Try running as administrator."^& vbcrlf ^&" "^& vbcrlf ^&"Information:"^& vbcrlf ^&"Access denied" ,48, "Error"^)>"%temp%\msg.vbs"
				start %temp%\msg.vbs
				endlocal
				exit /b 1
			)
			:: If the .mp3 player is Windows Media Player, install for Microsoft Groove as well
			if !val!==WMP11.AssocFile.MP3 (
				reg add "HKCR\AppXqj98qxeaynz6dv4459ayz6bnqxbyaqcs\shell\Add to Self Radio\command" /ve /d "%~f0 ""%%1""" >"%temp%\stderr.txt" 2>&1
				if !errorlevel!==1 (
					Echo x=msgbox^("An error occurred. Try running as administrator."^& vbcrlf ^&" "^& vbcrlf ^&"Information:"^& vbcrlf ^&"Access denied" ,48, "Error"^)>"%temp%\msg.vbs"
					start %temp%\msg.vbs
					endlocal
					exit /b 1
				)				
			) else (
				set ret=1
				call :menu
				:: Create uninstallation .reg file
				Echo Windows Registry Editor Version 5.00>Uninstall_AddToSelfRadio.reg
				Echo [-HKEY_CLASSES_ROOT\!val!\shell\Add to Self Radio]>>Uninstall_AddToSelfRadio.reg
				if !val!==WMP11.AssocFile.MP3 (
					Echo [-HKEY_CLASSES_ROOT\AppXqj98qxeaynz6dv4459ayz6bnqxbyaqcs\shell\Add to Self Radio]>>Uninstall_AddToSelfRadio.reg
				)
				Echo [-HKEY_CURRENT_USER\Software\FoddEx\Add to Self Radio]>>Uninstall_AddToSelfRadio.reg
				RUNDLL32.exe USER32.DLL,UpdatePerUserSystemParameters ,1 ,True
				echo x=msgbox^("Added registry entry"^& vbcrlf ^&"You can now right click on any .mp3 file and choose"^& vbcrlf ^&"Add to Self Radio" ,64, "Success"^)>"%temp%\msg.vbs"
				start %temp%\msg.vbs
				goto :end
			)
		) else (
			Echo x=msgbox^("Keys not added. Choose 'Y'." ,48, "Warning"^)>"%temp%\msg.vbs"
			start %temp%\msg.vbs
			goto :end
		)
	)
	:: Read the data in the Add to Self Radio command key
	for /f "skip=2 tokens=3*" %%B in ('reg query "HKCR\!val!\shell\Add to Self Radio\command" /ve') do (
		if not "%~1"=="" (
			goto :cnt
		)
		set regPath=%%~B
		:: Check if the path is unchanged
		if not "!regPath!"=="%~f0" (
			set action=_
			cls
			Echo.
			Echo Detected changes in program path.
			Echo.
			Echo NOTE: If you've previously used an older version of
			Echo       this software, you should close this program
			Echo       and run the uninstaller from that version
			Echo       before continuing.
			Echo.
			Echo Refresh registry entry?
			set /p action="Y/N >> "
			if !action!==_ (
				goto :end
			)
			if /i !action!==y (
				:: Renew the registry entry
				reg add "HKCR\!val!\shell\Add to Self Radio\command" /f /ve /d "%~f0 ""%%1""" >"%temp%\stderr.txt" 2>&1
				if !errorlevel!==1 (
					Echo x=msgbox^("An error occurred. Try running as administrator."^& vbcrlf ^&" "^& vbcrlf ^&"Information:"^& vbcrlf ^&"Access denied" ,48, "Error"^)>"%temp%\msg.vbs"
					start %temp%\msg.vbs
					endlocal
					exit /b 1
				)
				if !val!==WMP11.AssocFile.MP3 (
					reg add "HKCR\AppXqj98qxeaynz6dv4459ayz6bnqxbyaqcs\shell\Add to Self Radio\command" /f /ve /d "%~f0 ""%%1""" >"%temp%\stderr.txt" 2>&1
					if !errorlevel!==1 (
						Echo x=msgbox^("An error occurred. Try running as administrator."^& vbcrlf ^&" "^& vbcrlf ^&"Information:"^& vbcrlf ^&"Access denied" ,48, "Error"^)>"%temp%\msg.vbs"
						start %temp%\msg.vbs
						endlocal
						exit /b 1
					) else (
						:: Create new uninstallation .reg file
						Echo Windows Registry Editor Version 5.00>Uninstall_AddToSelfRadio.reg
						Echo [-HKEY_CLASSES_ROOT\!val!\shell\Add to Self Radio]>>Uninstall_AddToSelfRadio.reg
						Echo [-HKEY_CLASSES_ROOT\AppXqj98qxeaynz6dv4459ayz6bnqxbyaqcs\shell\Add to Self Radio]>>Uninstall_AddToSelfRadio.reg
						Echo [-HKEY_CURRENT_USER\Software\FoddEx\Add to Self Radio]>>Uninstall_AddToSelfRadio.reg
						RUNDLL32.exe USER32.DLL,UpdatePerUserSystemParameters ,1 ,True
						echo x=msgbox^("Updated registry entry" ,64, "Success"^)>"%temp%\msg.vbs"
						start %temp%\msg.vbs
						endlocal
						exit /b 0
					)
				) else (
					:: Create new uninstallation .reg file
					Echo Windows Registry Editor Version 5.00>Uninstall_AddToSelfRadio.reg
					Echo [-HKEY_CLASSES_ROOT\!val!\shell\Add to Self Radio]>>Uninstall_AddToSelfRadio.reg
					Echo [-HKEY_CURRENT_USER\Software\FoddEx\Add to Self Radio]>>Uninstall_AddToSelfRadio.reg
					RUNDLL32.exe USER32.DLL,UpdatePerUserSystemParameters ,1 ,True
					echo x=msgbox^("Updated registry entry" ,64, "Success"^)>"%temp%\msg.vbs"
					start %temp%\msg.vbs
					endlocal
					exit /b 0
				)
				goto :end
			) else (
				goto :end
			)
		)
	)
	:: Look for MODE value
	reg query "HKCU\Software\FoddEx\Add To Self Radio" /v "Mode" > nul
	if !errorlevel!==1 (
		cls
		Echo.
		Echo NOTE: If you've previously used an older version of
		Echo       this software, you should close the program
		Echo       and run the uninstaller from the older version
		Echo.
		Echo.
		Echo No mode is specified. Add mode now?
		Echo.
		set add=0
		set /p add="Y/N>> "
		if /i !add!==N (
			goto end
		)
		if /i !add!==Y (
			goto menu
		) else (
			goto end
		)
		goto end
	)
)
:: Go to menu if no file to process is specified
:cnt
if "%~1"=="" (
	goto menu
)
for /f "skip=2 tokens=3*" %%A in ('reg query "HKCU\Software\FoddEx\Add To Self Radio" /v "Mode"') do (
	if %%A==SHORTCUT (
		goto :shortcut
	)
	if %%A==COPY (
		goto :copy
	)
	Echo x=msgbox^("The registry query for MODE returned an invalid value."^& vbcrlf ^&"Run the uninstallation file, then run SelfRadioAdd.bat."^& vbcrlf ^&"Information:"^& vbcrlf ^&"VALUEDATA:%%A" ,48, "Error"^)>"%temp%\msg.vbs"
	start %temp%\msg.vbs
	endlocal
	exit /b 1
)
:copy
title Add to Self Radio v!version! - Adding %~nx1...
:: Check if the file already exists
if exist "!userDir!\!musicDIR!\%~nx1" (
	Echo x=msgbox^("A file called %~nx1 already exists." ,48, "Error"^)>"%temp%\msg.vbs"
	start %temp%\msg.vbs
	endlocal
	exit /b 1
)
:: Copy the file
xcopy "%~1" "!userDir!\!musicDir!" > nul
:: Check if the file was copied
if not exist "!userDir!\!musicDir!\%~nx1" (
	Echo x=msgbox^("Failed to add %~nx1"^& vbcrlf ^&"If this issue persists, you can post this information at the mod page:"^& vbcrlf ^&"FILE:%~1\\PATH:!userDir!\!musicDir!" ,48, "Error"^)>"%temp%\msg.vbs"
	start %temp%\msg.vbs
	endlocal
	exit /b 1
)
:: Display success message
echo x=msgbox^("%~1 has been added." ,64, "Success"^)>"%temp%\msg.vbs"
start %temp%\msg.vbs
goto :end
:end
endlocal
exit /b 0
:menu
:: Read settings from registry
for /f "skip=2 tokens=3*" %%A in ('reg query "HKCU\Software\FoddEx\Add To Self Radio" /v "Mode"') do (
	set currMode=%%A
)
if "!currMode!"=="" (
	set currMode=UNDEFINED
)
for /f "skip=2 tokens=3*" %%A in ('reg query "HKCU\Software\FoddEx\Add To Self Radio" /v "Ignore"') do (
	set currIgnore=%%A
)
if "!currIgnore!"=="" (
	set currIgnore=UNDEFINED
)
if !currIgnore!==0 (
	set currIgnore=FALSE
)
if !currIgnore!==1 (
	set currIgnore=TRUE
)
set mode=0
cls
Echo.
Echo Current mode:    !currMode!
Echo Ignore updates?: !currIgnore!
Echo ------------------------
Echo.
Echo Choose a mode:
Echo.
Echo 1 --^> Copy       ^(Copies the song to the Self Radio folder^)
Echo.
Echo 2 --^> Shortcut   ^(Creates a shortcut to the song in the Self Radio folder^)
Echo.
Echo.
Echo Ignore updates?
Echo.
Echo 3 --^> Yes        ^(Skips version checks^)
Echo.
Echo 4 --^> No         ^(Checks for version and displays a message if available^)
Echo.
Echo Settings can be changed later by running the program again.
Echo.
set /p mode=">> "
if !mode!==1 (
	:: Set mode to COPY
	set mode=COPY
	reg add "HKCU\Software\FoddEx\Add to Self Radio" /f /v "Mode" /d "!mode!" > nul
	if !errorlevel!==1 (
		Echo x=msgbox^("An error occurred. Try running as administrator."^& vbcrlf ^&" "^& vbcrlf ^&"Information:"^& vbcrlf ^&"REG ADD: Access denied." ,48, "Error"^)>"%temp%\msg.vbs"
		start %temp%\msg.vbs
		endlocal
		exit /b 1
	)
	if not defined ret (
		if !currIgnore!==UNDEFINED (
			goto menu
		)
		echo x=msgbox^("The mode has been successfully set to !mode!." ,64, "Success"^)>"%temp%\msg.vbs"
		start %temp%\msg.vbs
		goto :end
	)
	if !currIgnore!==UNDEFINED (
		goto menu
	)
	goto :eof
)
if !mode!==2 (
	:: Set mode to SHORTCUT
	set mode=SHORTCUT
	reg add "HKCU\Software\FoddEx\Add to Self Radio" /f /v "Mode" /d "!mode!" >"%temp%\stderr.txt" 2>&1
	if !errorlevel!==1 (
		Echo x=msgbox^("An error occurred. Try running as administrator."^& vbcrlf ^&" "^& vbcrlf ^&"Information:"^& vbcrlf ^&"Access denied" ,48, "Error"^)>"%temp%\msg.vbs"
		start %temp%\msg.vbs
		endlocal
		exit /b 1
	)
	if not defined ret (
		if !currIgnore!==UNDEFINED (
			goto menu
		)
		echo x=msgbox^("The mode has been successfully set to !mode!." ,64, "Success"^)>"%temp%\msg.vbs"
		start %temp%\msg.vbs
		goto :end
	)
	if !currIgnore!==UNDEFINED (
		goto menu
	)
	goto :eof
)
if !mode!==3 (
	:: Set IgnoreUpdates to TRUE
	reg add "HKCU\Software\FoddEx\Add to Self Radio" /f /v "Ignore" /d "1" >"%temp%\stderr.txt" 2>&1
	if !errorlevel!==1 (
		Echo x=msgbox^("An error occurred. Try running as administrator."^& vbcrlf ^&" "^& vbcrlf ^&"Information:"^& vbcrlf ^&"Access denied" ,48, "Error"^)>"%temp%\msg.vbs"
		start %temp%\msg.vbs
		endlocal
		exit /b 1
	)
	if !currMode!==UNDEFINED (
		goto menu
	)
	if not defined ret (
		echo x=msgbox^("Ignore updates has been set to TRUE." ,64, "Success"^)>"%temp%\msg.vbs"
		start %temp%\msg.vbs
	)
	goto :end0
)
if !mode!==4 (
	:: Set IgnoreUpdates to FALSE
	reg add "HKCU\Software\FoddEx\Add to Self Radio" /f /v "Ignore" /d "0" >"%temp%\stderr.txt" 2>&1
	if !errorlevel!==1 (
		Echo x=msgbox^("An error occurred. Try running as administrator."^& vbcrlf ^&" "^& vbcrlf ^&"Information:"^& vbcrlf ^&"Access denied" ,48, "Error"^)>"%temp%\msg.vbs"
		start %temp%\msg.vbs
		endlocal
		exit /b 1
	)
	if !currMode!==UNDEFINED (
		goto menu
	)
	if not defined ret (
		echo x=msgbox^("Ignore updates has been set to FALSE." ,64, "Success"^)>"%temp%\msg.vbs"
		start %temp%\msg.vbs
	)
	goto :end
)
goto :menu
:shortcut
title Add to Self Radio v!version! - Adding %~nx1...
:: Check if the link already exists
if exist "!userDir!\!musicDIR!\%~n1.lnk" (
	Echo x=msgbox^("A shortcut called %~n1.lnk already exists." ,48, "Error"^)>"%temp%\msg.vbs"
	start %temp%\msg.vbs
	endlocal
	exit /b 1
)
:: Create VBSscript file for shortcut creation.
set SCRIPT="%TEMP%\SelfRadioShortcut.vbs"
echo Set oWS = WScript.CreateObject^("WScript.Shell"^)>> !SCRIPT!
echo sLinkFile = "!userDir!\!musicDir!\%~n1.lnk">> !SCRIPT!
echo Set oLink = oWS.CreateShortcut^(sLinkFile^)>> !SCRIPT!
echo oLink.TargetPath = "%~1">> !SCRIPT!
echo oLink.Save>> !SCRIPT!
:: Run the script file
cscript /nologo !SCRIPT!
del /q !SCRIPT! > nul
if not exist "!userDir!\!musicDir!\%~n1.lnk" (
	Echo x=msgbox^("Failed to add a shortcut for %~n1"^& vbcrlf ^&"If this issue persists, you can post this information at the mod page:"^& vbcrlf ^&"FILE:%~1\\PATH:!userDir!\!musicDir!" ,48, "Error"^)>"%temp%\msg.vbs"
	start %temp%\msg.vbs
	endlocal
	exit /b 1
)
:: Display success message
echo x=msgbox^("A shortcut to %~1 has been added." ,64, "Success"^)>"%temp%\msg.vbs"
start %temp%\msg.vbs
goto :end
:end
:: Check if updates should be ignored or not
for /f "skip=2 tokens=3*" %%A in ('reg query "HKCU\Software\FoddEx\Add To Self Radio" /v "Ignore"') do (
	set ignoreUpdates=%%A
)
if !ignoreUpdates!==0 (
	Echo.
	Echo Looking for updates...
	:: Check internet connection
	ping google.com -n 1 -w 1000 > nul
	if !errorlevel!==1 (
		goto end0
	)
	:: Download version info
	powershell -Command "& {Invoke-WebRequest "http://wearegoth.altervista.org/kaspercoding/a2sr/version.txt" -OutFile "%temp%\a2srVersion.txt";}">nul
	for /f "tokens=1-3 delims=." %%A in (%temp%\a2srVersion.txt) do (
		set newVersion=%%A.%%B.%%C
		:: Match downloaded version info with local version info
		for /f "tokens=1-3 delims=." %%D in ("!version!") do (
			if %%A GTR %%D (
				goto end1
			)
			if %%B GTR %%E (
				goto end1
			)
			if %%C GTR %%F (
				goto end1
			)
			goto end0
		)
	)
)
goto end0
:end1
:: Download patch notes and parse into a VBScript message
powershell -Command "& {Invoke-WebRequest "http://wearegoth.altervista.org/kaspercoding/a2sr/notes.txt" -OutFile "%temp%\a2srNotes.txt";}">nul
set vbMessage=x=msgbox^("An update is available."^& vbcrlf ^&" "^& vbcrlf ^&"Your version: v!version!"^& vbcrlf ^&"New version: v!newVersion!"^& vbcrlf ^&" "^& vbcrlf ^&"What's new:"
for /f "tokens=*" %%A in (%temp%\a2srNotes.txt) do (
	set vbMessage=!vbMessage!^& vbcrlf ^&" "^& vbcrlf ^&"%%A"
)
set vbMessage=!vbMessage!^& vbcrlf ^&" "^& vbcrlf ^&"Click 'Yes' to go to the GTA5-Mods.com download page",vbYesNo,"Add to Self Radio"^)
:: Create VBScript notification
(
	echo Set objShell = CreateObject^("Wscript.Shell"^)
	echo !vbMessage!
	echo If x = vbYes Then
	echo     objShell.Run^("https://www.gta5-mods.com/tools/add-to-self-radio"^)
	echo Else
	echo     Wscript.Quit
	echo End If
)>"%temp%\msg.vbs"
%temp%\msg.vbs
goto end0
:end0
:: Delete temporary files generated by the program
del /q "%temp%\a2srNotes.txt" > nul
del /q "%temp%\a2srVersion.txt" > nul
del /q "%temp%\msg.vbs" > nul
:: Line below commented out for debugging purposes. Remove  "::" to enable deletion of error log (Will add an option in the settings in a future update)
:: del /q "%temp%\stderr.txt" > nul
:: Exit
endlocal
exit /b 0