@Echo off
setlocal enabledelayedexpansion
title Add to Self Radio - Troubleshooter
color 8F
del /q info.txt>nul
:main
set action=_
cls
Echo.
Echo This program collects computer information
Echo for troubleshooting.
Echo.
Echo Press A to see what information is collected
Echo Press any other key to start collecting.
Echo.
set /p action=">> "
if /i !action!==A (
	goto main.info
)
goto collect
:main.info
cls
Echo.
Echo This data will be collected:
Echo.
Echo - Registry data related to installed media players
Echo - Add to Self Radio and media player registry data
Echo - Program path
Echo - Windows username
Echo - Windows OS version
Echo - USERPROFILE environment variable
Echo - HOMEPATH environment variable
Echo - HOMEDRIVE environment variable
Echo - Personal Shell Folder registry value ^(My Documents path^)
Echo.
Echo Press any key to return...
pause > nul
goto main
:collect
title Troubleshooter - Collecting data...
:collect.defaultMP
(
	Echo R E G I S T R Y   D A T A
	Echo -------------------------------------------------------
	Echo ***DEFAULT MEDIA PLAYER***
	reg query HKCR\.mp3 /ve
	Echo -------------------------------------------------------
	Echo ***GROOVE***
	reg query "HKCR\AppXqj98qxeaynz6dv4459ayz6bnqxbyaqcs"
	reg query "HKCR\AppXqj98qxeaynz6dv4459ayz6bnqxbyaqcs\Shell\Add to Self Radio\command" /ve
	Echo -------------------------------------------------------
	Echo ***WMP11***
	reg query "HKCR\WMP11.AssocFile.MP3"
	reg query "HKCR\WMP11.AssocFile.MP3\Shell\Add to Self Radio\command" /ve
	Echo -------------------------------------------------------
	Echo ***VLC***
	reg query "HKCR\VLC.mp3"
	reg query "HKCR\VLC.mp3\Shell\Add to Self Radio\command" /ve
	Echo -------------------------------------------------------
	Echo -------------------------------------------------------
	Echo W I N D O W S   D A T A
	Echo -------------------------------------------------------
	echo WindowsUsername=!USERNAME!
	for /f "tokens=2 delims==" %%A in ('wmic os get caption /format:value') do (
		echo **%%A>x
		for /f "tokens=*" %%B in (x) do (
			set WindowsCaption=%%B
			set WindowsCaption=!WindowsCaption:~2!
		)
		del /q x>nul
	)
	Echo WindowsCaption=!WindowsCaption!
	for /f "tokens=2 delims==" %%A in ('wmic os get version /format:value') do (
		Echo **%%A>x
		for /f "tokens=*" %%B in (x) do (
			set WindowsVersion=%%B
			set WindowsVersion=!WindowsVersion:~2!
		)
		del /q x>nul
	)
	Echo WindowsVersion=!WindowsVersion!
	Echo HomeDrive=!HomeDrive!
	Echo HomePath=!HomePath!
	Echo CombinedHomeDriveAndPath=!HomeDrive!!HomePath!
	Echo UserProfile=!UserProfile!
	reg query "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders" /v "Personal"
	Echo -------------------------------------------------------
	Echo -------------------------------------------------------
	Echo A 2 S R   D A T A
	Echo -------------------------------------------------------
	reg query "HKCU\Software\FoddEx\Add to Self Radio"
	Echo.
	Echo Troubleshooter path: "%~dp0"
	cd..
	if not exist SelfRadioAdd.bat (
		Echo MAIN PROGRAM ISN'T IN EXPECTED FOLDER.
	) else (
		echo MAIN PROGRAM IS IN EXPECTED FOLDER.
	)
	Echo -------------------------------------------------------
	cd "%~dp0"
)>info.txt 2>&1
@Echo off
title Troubleshooter - Collection complete
echo.
echo.
Echo Collection complete.
Echo You can view the data in the info.txt file.
Echo.
Echo Press any key to exit...
pause > nul
endlocal
exit